import Live
from consts import *

def getSong():
    """Gets a the current Song instance"""
    return Live.Application.get_application().get_document()

def getScene(num):
    scenes = getSong().scenes
    
    if num < len(scenes):
        return scenes[num]
    else:
        return None
    
def getTrack(num):
    """Returns track number (num) (starting at 0)"""
    tracks = getSong().tracks
    
    if num < len(tracks):
        return tracks[num]
    else:
        return None

def getClip(track,scene):
    track = getTrack(track)
    if track and scene < len(track.clip_slots):
        clipSlot = track.clip_slots[scene]
        if clipSlot.has_clip:
            return clipSlot.clip
    return None

def getClipSlot(track,scene):
    track = getTrack(track)
    if track and scene < len(track.clip_slots):
        return track.clip_slots[scene]
    return None
    
def translateString(text):
    """
    Convert a string into a sysex safe string
    """
    result = ()
    length = len(text)
    for i in range(0,length):
        charCode = ord(text[i])
        if charCode < 32:
            charCode = 32
        elif charCode > 127:
            charCode = 127
        result = (result + (charCode,))
    return result

def mapAllCCs(script_handle, midi_map_handle, channel):
    for cc in range(127):
        Live.MidiMap.forward_midi_cc(script_handle,midi_map_handle,channel,cc)
