autowatch = 1;
inlets = 1;
setinletassist(0,"Sysex data");
outlets = 2;
setoutletassist(1,"Sysex data");
setoutletassist(0,"Info");

SYSEX_START = 240;
SYSEX_END = 247;

// States for the basic sysex decoder state machine
IDLE = 1;
TYPE = 2;
DATA = 3;
FINISHED = 4;
state = IDLE;

commandType = 0;
data = [];

// Command type for general info from live (welcome / goodbye messages etc..)
INFO = 0;
// Sets of commands should use contiguous numbers, makes it easier to
// do the first decoding pass. See consts.py or LiveModel.js for the actual commands
CLIP_COMMANDS_LOW = 1;
CLIP_COMMANDS_HIGH = 6;

TRACK_COMMANDS_LOW = 10;
TRACK_COMMANDS_HIGH = 15;

SCENE_COMMANDS_LOW = 30;
SCENE_COMMANDS_HIGH = 32;

// Simple state machine for pulling the data out of sysex messages
function msg_int(a)
{
	if(a == SYSEX_START)
	{
		// Clear the data buffer
		data = [];
		// Waiting for command type byte
		state = TYPE;
	}
	else if(a == SYSEX_END)
	{
		state = FINISHED;
		//post("Received " + data.length + " data bytes\n");
		decode()
		state = IDLE;
	}
	else if(state == TYPE)
	{
		commandType = a
		// Waiting for data
		state = DATA;
	}
	else if(state == DATA)
	{
		data.push(a)
	}
}

function decode()
{
	if(commandType == INFO)
	{
		message = byteToString(data);
		outlet(0,message);
	}
	else if(commandType >= CLIP_COMMANDS_LOW && commandType <= CLIP_COMMANDS_HIGH)
	{
		outlet(1,"clipData",{command:commandType,data:data});
	}
	else if(commandType >= TRACK_COMMANDS_LOW && commandType <= TRACK_COMMANDS_HIGH)
	{
		outlet(1,"trackData",{command:commandType,data:data});
	}
	else if(commandType >= SCENE_COMMANDS_LOW && commandType <= SCENE_COMMANDS_HIGH)
	{
		outlet(1,"sceneData",{command:commandType,data:data});
	}
	else
	{
		post("Unrecognized command type : " + commandType + " : " + data + "\n");
	}
}

// Convert an array of bytes to a string
function byteToString(byteArray)
{
	var str = "";
	for(i = 0;i<byteArray.length;i++)
	{
		str += String.fromCharCode(byteArray[i]);
	}
	return str;
}